Const cNotConnected = 0
Const cConnectedAsServer = 1
Const cConnectetAsClient = 2

Global Subnetmask
Global IPAdress
Global BroadcastIP

Global Connected, ConnectingTime
Global Stream
Global SendTime

Global MSec

Local Succ

Type TUser
	Field ip
	Field port
	Field buffer
	Field contact
	Field sendtime
	Field name$
End Type

Type TMessage
	Field txt$
	Field colour
End Type

Type TInput
	Field txtL$, txtR$
	Field CursorBlink, CursorBlinkTime
End Type
Local inp.TInput = New TInput

Local MessageAddTime
Local msg.TMessage
Local row
Local inputmsg$
Local User.TUser

Graphics 640, 480, 0, 2
SetBuffer BackBuffer()

; Subnetzmaske und Broadcast-IP bestimmen
Succ = GetSubnetmask()
If Not Succ Then NRuntimeError "Fehler:/n- Die Subnetzmaske kann nicht bestimmt werden./n/nVersuchen Sie, das Programm von einem anderen Ort auszufhren."
BroadcastIP = ( IPAdress And Subnetmask ) Or ( ~Subnetmask )

AppTitle "Lanchat"

While Not KeyDown(1)
	MSec = MilliSecs()

	Cls

	UpdateNetwork
	
	row = 0
	For msg = Each TMessage
		Color 0,0, msg\colour
		Text 0, row *16, msg\txt
		row = row +1
		If row > 28
			Delete First TMessage
			row = row -1
		EndIf
	Next
	
	inputmsg = Input( inp )
	If inputmsg <> ""
		If Connected <> cNotConnected
			For User = Each TUser
				If User\contact
					BufferByte User, $10
					BufferString User, inputmsg
				EndIf
			Next
		EndIf
		NewMessage( "localhost > " +inputmsg, $CCCCCC )
	EndIf
	
	Flip
Wend

End




; ermittelt die Subnetzmaske
Function GetSubnetmask()
	Local CurDir$ = CurrentDir()
	; ipconfig ausfhren, mit Ergebnisdatei
	ExecFile "cmd /c ipconfig >" +Chr(34) +CurDir +Chr(34) +"ipconfig.txt"
	; versuchen, die Datei zu finden
	Local Dir = ReadDir( CurDir )
	Local FileT, FileN$, File
	Local txt$
	Local StartSearchingLogfile = MilliSecs()
	.FindLogFile
	Repeat
		FileN = NextFile( Dir )
		If FileN = ""
			; Datei konnte nicht gefunden werden
			If MilliSecs() > StartSearchingLogfile +1500
				Return False
			Else
				Exit
			EndIf
		EndIf
		If FileN = "ipconfig.txt"
			; Datei auslesen
			File = ReadFile( CurDir +FileN )
			While Not Eof( File )
				txt = ReadLine( File )
				If Instr( Lower(txt), "subnet" ) > 0
					; Subnetzmaske aus entsprechender Zeile extrahieren
					Subnetmask = ReadAdress( txt )
				ElseIf Instr( Lower(txt), "ip-ad" ) > 0
					; IP-Adresse aus entsprechender Zeile extrahieren
					IPAdress = ReadAdress( txt )
				EndIf
			Wend
			CloseFile File
			CloseDir Dir
			Return True
		EndIf
	Forever
	CloseDir Dir
	Dir = ReadDir( CurDir )
	Delay 100
	Goto FindLogFile
End Function

; aus einem Text eine Adresse auslesen
Function ReadAdress( txt$ )
	Local ln, a, pt, Adress[3]
	ln = Len(txt)
	a = ln
	pt = 3
	; Text von hinten abarbeiten
	Repeat
		; Adressteile extrahieren
		If Mid( txt, a, 1 ) = "." Or Mid( txt, a, 1 ) = " "
			Adress[pt] = Mid( txt, a +1 )
			pt = pt -1
			If pt < 0
				; Adresse komplett, Adresse zurckgeben
				Return (Adress[0] Shl 24) +(Adress[1] Shl 16) +(Adress[2] Shl 8) +Adress[3]
			EndIf
			txt = Left( txt, a -1 )
		EndIf
		a = a -1
	Forever
End Function

; erweiterte RuntimeError-Funktion
Function NRuntimeError( msg$ )
	Local NewLine$ = Chr(10) +Chr(13)
	msg = Replace( msg, "/n", NewLine )
	RuntimeError msg
End Function

; der ganze Netzwerk-Krams
Function UpdateNetwork()
	Local msg.TMessage
	Local inAvail, inIP, inPort, inMsgType
	
	Local a
	Local byte1, byte2
	Local short1
	Local int1
	Local string1$

	Local User.TUser, UserFrom.TUser, UserTo.TUser

	; Verbindung aufbauen
	If Connected = cNotConnected
		If ConnectingTime = 0
			ConnectingTime = MSec +10000
			NewMessage( "Suche nach Host...", $CCCCFF )
			Stream = CreateUDPStream()
			If Not Stream Then NRuntimeError "Fehler:/n- Der Netzwerkstream kann nicht erstellt werden."
		ElseIf MSec => ConnectingTime
			NewMessage( "Kein Host gefunden, agiere nun selber als Host.", $CCCCFF )
			Connected = cConnectedAsServer
			CloseUDPStream Stream
			Stream = CreateUDPStream( 40000 )
			If Not Stream Then NRuntimeError "Fehler:/n- Der Netzwerkstream kann nicht erstellt werden."
			AppTitle "Lanchat - Host"
		ElseIf MSec => SendTime
			SendTime = MSec +1000
			WriteByte Stream, $A0
			WriteByte Stream, 0
			WriteByte Stream, 10
			SendUDPMsg Stream, BroadcastIP, 40000
		EndIf
	EndIf
	
	Repeat
		inIP = RecvUDPMsg( Stream )
		inPort = UDPMsgPort( Stream )
		If inIP <> 0
		User = GetUserbyIPnPort( inIP, inPort )
		Repeat
			inAvail = ReadAvail( Stream )
			inMsgType = ReadByte( Stream )
			; Nachrichtentyp
			Select inMsgType
			Case $10
				int1 = ReadInt( Stream )
				string1 = ""
				For a = 1 To int1
					string1 = string1 +Chr( ReadByte( Stream ))
				Next
				If Connected = cConnectedAsServer
					For UserTo = Each TUser
						If UserTo <> User
							BufferByte UserTo, $11
							BufferInt UserTo, User\ip
							BufferShort UserTo, User\port
							BufferString UserTo, string1
						EndIf
					Next
					NewMessage( User\name +" > " +string1, $FFFFFF )
				Else
					NewMessage( User\name +" > " +string1, $FFFFFF )
				EndIf
			Case $11
				int1 = ReadInt( Stream )
				short1 = ReadShort( Stream )
				UserFrom = GetUserbyIPnPort( int1, short1 )
				int1 = ReadInt( Stream )
				string1 = ""
				For a = 1 To int1
					string1 = string1 +Chr( ReadByte( Stream ))
				Next
				newmessage( userfrom\name +" > " +string1, $FFFFFF )
			Case $A0
				byte1 = ReadByte( Stream )
				byte2 = ReadByte( Stream )
				If byte1 = 0 And byte2 = 10
					If Connected = cConnectedAsServer
						BufferByte User, $A1
						User\contact = True
					EndIf
				EndIf
			Case $A1
				If Connected = cNotConnected
					User\contact = True
					NewMessage( "Verbunden.", $00FF00 )
					Connected = cConnectetAsClient
					AppTitle "Lanchat - Client"
					BufferByte User, $A2
				EndIf
			Case $A2
				If Connected = cConnectedAsServer
					NewMessage( User\name +" tritt dem Gesprch bei.", $00FF00 )
					For UserFrom = Each TUser
						If UserFrom <> User
							BufferByte User, $A3
							BufferInt User, UserFrom\ip
							BufferShort User, UserFrom\port
						EndIf
					Next
					For UserTo = Each TUser
						If UserTo <> User And userto\contact = True
							BufferByte UserTo, $A3
							BufferInt UserTo, User\ip
							BufferShort UserTo, User\port
						EndIf
					Next
				EndIf
			Case $A3
				int1 = ReadInt( Stream )
				short1 = ReadShort( Stream )
				UserFrom = getuserbyipnport( int1, short1 )
				NewMessage( UserFrom\name +" tritt dem Gesprch bei.", $00FF00 )
			End Select
		Until inAvail = 0
		EndIf
	Until inIP = 0
	
	For User = Each TUser
		If MSec => User\sendtime And User\contact = True
			If BankSize( User\buffer ) > 0
				WriteBytes User\buffer, Stream, 0, BankSize( User\buffer )
				SendUDPMsg Stream, User\ip, User\port
				ResizeBank User\buffer, 0
			EndIf
			User\sendtime = MSec +200
		EndIf
	Next
	
End Function

; einen Teilnehmer anhand der IP und des Ports identifizieren
Function GetUserbyIPnPort.TUser( ip, port )
	Local User.TUser

	For User = Each TUser
		If User\ip = ip And User\port = port Then Return User
	Next
	
	User = New TUser
	User\ip = ip
	User\port = port
	User\buffer = CreateBank()
	User\name = DottedIP( User\ip ) +":" +User\port
	Return User
End Function

; speichert ein Byte im spezifischen Buffer
Function BufferByte( User.TUser, Byte )
	Local offset = BankSize( User\buffer )
	ResizeBank User\buffer, offset +1
	PokeByte User\buffer, offset, Byte
End Function
; speichert ein Short im spezifischen Buffer
Function BufferShort( User.TUser, Bytes )
	Local offset = BankSize( User\buffer )
	ResizeBank User\buffer, offset +2
	PokeShort User\buffer, offset, Bytes
End Function
; speichert ein Integer im spezifischen Buffer
Function BufferInt( User.TUser, Bytes )
	Local offset = BankSize( User\buffer )
	ResizeBank User\buffer, offset +4
	PokeInt User\buffer, offset, Bytes
End Function
; speichert einen String im spezifischen Buffer
Function BufferString( User.TUser, Bytes$ )
	Local a, ln = Len( Bytes )
	Local offset = BankSize( User\buffer )
	ResizeBank User\buffer, offset +4 +ln
	PokeInt User\buffer, offset, ln
	For a = 1 To ln
		PokeByte User\buffer, offset +3 +a, Asc( Mid( Bytes, a, 1 ) )
	Next
End Function

; erstellt eine neue Textnachricht
Function NewMessage( txt$, colour )
	Local msg.TMessage = New TMessage
	msg\txt = Left( txt, 79 )
	msg\colour = colour
	If Len( txt ) > 79
		txt = Mid( txt, 80 )
		NewMessage( txt, colour )
	EndIf
End Function

; verbesserte Eingaberoutine
Function Input$( inp.TInput )
	Local txt$
	Local gk = GetKey()
	If gk => 32
		If Len( inp\txtL +inp\txtR ) < 79
			inp\txtL = inp\txtL +Chr(gk)
		EndIf
	ElseIf gk = 8
		If Len( inp\txtL ) > 0
			inp\txtL = Left( inp\txtL, Len( inp\txtL ) -1 )
		EndIf
	ElseIf gk = 13
		txt = inp\txtL +inp\txtR
		inp\txtL = ""
		inp\txtR = ""
		Return txt
	ElseIf KeyHit(203)
		If Len( inp\txtL ) > 0
			inp\txtR = Mid( inp\txtL, Len( inp\txtL ), 1 ) +inp\txtR
			inp\txtL = Left( inp\txtL, Len( inp\txtL ) -1 )
		EndIf
	ElseIf KeyHit(205)
		If Len( inp\txtR ) > 0
			inp\txtL = inp\txtL +Left( inp\txtR, 1 )
			inp\txtR = Mid( inp\txtR, 2 )
		EndIf
	ElseIf KeyHit(199)
		inp\txtR = inp\txtL +inp\txtR
		inp\txtL = ""
	ElseIf KeyHit(207)
		inp\txtL = inp\txtL +inp\txtR
		inp\txtR = ""
	ElseIf KeyHit(211)
		If Len( inp\txtR ) > 0
			inp\txtR = Mid( inp\txtR, 2 )
		EndIf
	EndIf
	
	If MSec => inp\CursorBlinkTime
		inp\CursorBlinkTime = MSec +200
		inp\CursorBlink = 1 -inp\CursorBlink
	EndIf
	Color 0,0,$FFFFFF
	If inp\CursorBlink
		Rect StringWidth( inp\txtL ), 460, 2, 16
	EndIf
	Text 0, 460, inp\txtL +inp\txtR
End Function
;~IDEal Editor Parameters:
;~C#Blitz3D